"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FILTERS = exports.COMPARE_ALL_OPTIONS = void 0;
Object.defineProperty(exports, "FilterStateStore", {
  enumerable: true,
  get: function () {
    return _esQuery.FilterStateStore;
  }
});
exports.fromKueryExpression = exports.enableFilter = exports.disableFilter = exports.dedupFilters = exports.decorateQuery = exports.compareFilters = exports.buildRangeFilter = exports.buildQueryFromFilters = exports.buildQueryFilter = exports.buildPhrasesFilter = exports.buildPhraseFilter = exports.buildFilter = exports.buildExistsFilter = exports.buildEsQuery = exports.buildEmptyFilter = exports.buildCustomFilter = void 0;
Object.defineProperty(exports, "getEsQueryConfig", {
  enumerable: true,
  get: function () {
    return _get_es_query_config.getEsQueryConfig;
  }
});
exports.uniqFilters = exports.toggleFilterNegated = exports.toggleFilterDisabled = exports.toElasticsearchQuery = exports.pinFilter = exports.onlyDisabledFiltersChanged = exports.nodeTypes = exports.nodeBuilder = exports.luceneStringToDsl = exports.isRangeFilter = exports.isQueryStringFilter = exports.isPhrasesFilter = exports.isPhraseFilter = exports.isMatchAllFilter = exports.isFilters = exports.isFilterPinned = exports.isFilterDisabled = exports.isFilter = exports.isExistsFilter = exports.getPhraseFilterValue = exports.getPhraseFilterField = void 0;
var _get_es_query_config = require("./get_es_query_config");
var _esQuery = require("@kbn/es-query");
/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */

// NOTE: Trick to deprecate exports https://stackoverflow.com/a/49152018/372086

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const isFilter = exports.isFilter = _esQuery.isFilter;
/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const isFilterDisabled = exports.isFilterDisabled = _esQuery.isFilterDisabled;
/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const disableFilter = exports.disableFilter = _esQuery.disableFilter;
/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const fromKueryExpression = exports.fromKueryExpression = _esQuery.fromKueryExpression;
/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const toElasticsearchQuery = exports.toElasticsearchQuery = _esQuery.toElasticsearchQuery;
/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const nodeTypes = exports.nodeTypes = _esQuery.nodeTypes;
/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const buildEsQuery = exports.buildEsQuery = _esQuery.buildEsQuery;
/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const buildQueryFromFilters = exports.buildQueryFromFilters = _esQuery.buildQueryFromFilters;
/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const luceneStringToDsl = exports.luceneStringToDsl = _esQuery.luceneStringToDsl;
/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const decorateQuery = exports.decorateQuery = _esQuery.decorateQuery;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const getPhraseFilterField = exports.getPhraseFilterField = _esQuery.getPhraseFilterField;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const getPhraseFilterValue = exports.getPhraseFilterValue = _esQuery.getPhraseFilterValue;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const isFilterPinned = exports.isFilterPinned = _esQuery.isFilterPinned;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const nodeBuilder = exports.nodeBuilder = _esQuery.nodeBuilder;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const isFilters = exports.isFilters = _esQuery.isFilters;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const uniqFilters = exports.uniqFilters = _esQuery.uniqFilters;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const onlyDisabledFiltersChanged = exports.onlyDisabledFiltersChanged = _esQuery.onlyDisabledFiltersChanged;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const isExistsFilter = exports.isExistsFilter = _esQuery.isExistsFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const isMatchAllFilter = exports.isMatchAllFilter = _esQuery.isMatchAllFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const isPhraseFilter = exports.isPhraseFilter = _esQuery.isPhraseFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const isPhrasesFilter = exports.isPhrasesFilter = _esQuery.isPhrasesFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const isRangeFilter = exports.isRangeFilter = _esQuery.isRangeFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const isQueryStringFilter = exports.isQueryStringFilter = _esQuery.isQueryStringFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const buildQueryFilter = exports.buildQueryFilter = _esQuery.buildQueryFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const buildPhrasesFilter = exports.buildPhrasesFilter = _esQuery.buildPhrasesFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const buildPhraseFilter = exports.buildPhraseFilter = _esQuery.buildPhraseFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const buildRangeFilter = exports.buildRangeFilter = _esQuery.buildRangeFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const buildCustomFilter = exports.buildCustomFilter = _esQuery.buildCustomFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const buildFilter = exports.buildFilter = _esQuery.buildFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const buildEmptyFilter = exports.buildEmptyFilter = _esQuery.buildEmptyFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const buildExistsFilter = exports.buildExistsFilter = _esQuery.buildExistsFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const toggleFilterNegated = exports.toggleFilterNegated = _esQuery.toggleFilterNegated;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const enableFilter = exports.enableFilter = _esQuery.enableFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const pinFilter = exports.pinFilter = _esQuery.pinFilter;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const toggleFilterDisabled = exports.toggleFilterDisabled = _esQuery.toggleFilterDisabled;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const compareFilters = exports.compareFilters = _esQuery.compareFilters;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const dedupFilters = exports.dedupFilters = _esQuery.dedupFilters;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const COMPARE_ALL_OPTIONS = exports.COMPARE_ALL_OPTIONS = _esQuery.COMPARE_ALL_OPTIONS;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */
const FILTERS = exports.FILTERS = _esQuery.FILTERS;

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */

/**
 * @deprecated Import from the "@kbn/es-query" package directly instead.
 * @removeBy 8.1
 */