"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.caseStatuses = exports.CasesStatusResponseRt = exports.CasesStatusRequestRt = exports.CaseStatuses = exports.CaseStatusRt = void 0;
var rt = _interopRequireWildcard(require("io-ts"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0; you may not use this file except in compliance with the Elastic License
 * 2.0.
 */
let CaseStatuses = exports.CaseStatuses = /*#__PURE__*/function (CaseStatuses) {
  CaseStatuses["open"] = "open";
  CaseStatuses["in-progress"] = "in-progress";
  CaseStatuses["closed"] = "closed";
  return CaseStatuses;
}({});
const CaseStatusRt = exports.CaseStatusRt = rt.union([rt.literal(CaseStatuses.open), rt.literal(CaseStatuses['in-progress']), rt.literal(CaseStatuses.closed)]);
const caseStatuses = exports.caseStatuses = Object.values(CaseStatuses);
const CasesStatusResponseRt = exports.CasesStatusResponseRt = rt.type({
  count_open_cases: rt.number,
  count_in_progress_cases: rt.number,
  count_closed_cases: rt.number
});
const CasesStatusRequestRt = exports.CasesStatusRequestRt = rt.partial({
  /**
   * The owner of the cases to retrieve the status stats from. If no owner is provided the stats for all cases
   * that the user has access to will be returned.
   */
  owner: rt.union([rt.array(rt.string), rt.string])
});