"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getLogSourceConfigurationSuccessResponsePayloadRT = exports.getLogSourceConfigurationResponsePayloadRT = exports.getLogSourceConfigurationRequestParamsRT = exports.getLogSourceConfigurationErrorResponsePayloadRT = void 0;
var rt = _interopRequireWildcard(require("io-ts"));
var _shared = require("../shared");
var _log_source_configuration = require("../../log_sources/log_source_configuration");
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0; you may not use this file except in compliance with the Elastic License
 * 2.0.
 */

/**
 * request
 */

const getLogSourceConfigurationRequestParamsRT = exports.getLogSourceConfigurationRequestParamsRT = rt.type({
  // the id of the source configuration
  sourceId: rt.string
});
/**
 * response
 */

const getLogSourceConfigurationSuccessResponsePayloadRT = exports.getLogSourceConfigurationSuccessResponsePayloadRT = rt.intersection([rt.type({
  data: _log_source_configuration.logSourceConfigurationRT
}), rt.partial({
  timing: _shared.routeTimingMetadataRT
})]);
const getLogSourceConfigurationErrorResponsePayloadRT = exports.getLogSourceConfigurationErrorResponsePayloadRT = rt.union([_shared.badRequestErrorRT, _shared.forbiddenErrorRT]);
const getLogSourceConfigurationResponsePayloadRT = exports.getLogSourceConfigurationResponsePayloadRT = rt.union([getLogSourceConfigurationSuccessResponsePayloadRT, getLogSourceConfigurationErrorResponsePayloadRT]);