"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usageMetricSavedObjectType = exports.savedQuerySavedObjectType = exports.packSavedObjectType = void 0;
/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0; you may not use this file except in compliance with the Elastic License
 * 2.0.
 */

const savedQuerySavedObjectType = exports.savedQuerySavedObjectType = 'osquery-saved-query';
const packSavedObjectType = exports.packSavedObjectType = 'osquery-pack';
const usageMetricSavedObjectType = exports.usageMetricSavedObjectType = 'osquery-manager-usage-metric';

/**
 * This makes any optional property the same as Required<T> would but also has the
 * added benefit of keeping your undefined.
 *
 * For example:
 * type A = RequiredKeepUndefined<{ a?: undefined; b: number }>;
 *
 * will yield a type of:
 * type A = { a: undefined; b: number; }
 *
 */